# -*- coding: utf-8 -*-

# Form implementation generated from reading ui file '.\ble_gui.ui'
#
# Created by: PyQt5 UI code generator 5.11.3
#
# WARNING! All changes made in this file will be lost!

from PyQt5 import QtCore, QtGui, QtWidgets
from PyQt5.QtGui import QIcon, QPixmap
from PyQt5.QtWidgets import *
from PyQt5.QtCore import *
from PyQt5.QtGui import *

from bluepy import btle
from bluepy.btle import UUID, Peripheral,DefaultDelegate
import struct
import sys
import time

class Ui_MainWindow(object):
    def setupUi(self, MainWindow):
        self.picture_flag0 = 0
        self.picture_flag1 = 0
        self.picture_flag2 = 0
        
        self.temperature_data = [0] * 60
        self.adc_data = [0] * 60
    
        MainWindow.setObjectName("MainWindow")
        MainWindow.resize(1100, 830)
        self.centralwidget = QtWidgets.QWidget(MainWindow)
        self.centralwidget.setObjectName("centralwidget")
        #Temperature Graph
        self.graphicsView_temp = PlotWidget(self.centralwidget)
        self.graphicsView_temp.setGeometry(QtCore.QRect(470, 60, 620, 300))
        self.graphicsView_temp.setObjectName("graphicsView_temp")
        self.graphicsView_temp.setMouseEnabled(x=False, y=False)
        self.graphicsView_temp.setYRange(0,40)
        self.graphicsView_temp.setXRange(0,60)
        self.graphicsView_temp.setLabel('bottom', "Time [s]")
        self.graphicsView_temp.setLabel('left', "Temperature [°C]")
        #Gyroskop Graph
        self.graphicsView_gyro = PlotWidget(self.centralwidget)
        self.graphicsView_gyro.setGeometry(QtCore.QRect(470, 480, 620, 300))
        self.graphicsView_gyro.setObjectName("graphicsView_gyro")
        self.graphicsView_gyro.setMouseEnabled(x=False, y=False)
        self.graphicsView_gyro.setYRange(0,3300)
        self.graphicsView_gyro.setXRange(0,50)
        self.graphicsView_gyro.setLabel('bottom', "Time [s]")
        self.graphicsView_gyro.setLabel('left', "Vbatt [mV]")
        #BTN LED0
        self.pushButton_LED0 = QtWidgets.QPushButton(self.centralwidget)
        self.pushButton_LED0.setGeometry(QtCore.QRect(40, 170, 131, 31))
        self.pushButton_LED0.setObjectName("pushButton_LED0")
        self.pushButton_LED0.setText("LED0")
        self.pushButton_LED0.setToolTip('This is an example button')
        #BTN LED1
        self.pushButton_LED1 = QtWidgets.QPushButton(self.centralwidget)
        self.pushButton_LED1.setGeometry(QtCore.QRect(240, 170, 131, 31))
        self.pushButton_LED1.setObjectName("pushButton_LED1")
        #BTN LED2
        self.pushButton_LED2 = QtWidgets.QPushButton(self.centralwidget)
        self.pushButton_LED2.setGeometry(QtCore.QRect(40, 330, 131, 31))
        self.pushButton_LED2.setObjectName("pushButton_LED2")
        #LED label
        self.label_LED = QtWidgets.QLabel(self.centralwidget)
        self.label_LED.setGeometry(QtCore.QRect(20, 20, 101, 31))
        self.label_LED.setBaseSize(QtCore.QSize(0, 0))
        self.label_LED.setFrameShape(QtWidgets.QFrame.Box)
        self.label_LED.setTextFormat(QtCore.Qt.AutoText)
        self.label_LED.setAlignment(QtCore.Qt.AlignCenter)
        self.label_LED.setOpenExternalLinks(False)
        self.label_LED.setObjectName("label_LED")
        #Temperature label
        self.label_temp = QtWidgets.QLabel(self.centralwidget)
        self.label_temp.setGeometry(QtCore.QRect(470, 20, 101, 40))
        self.label_temp.setBaseSize(QtCore.QSize(0, 0))
        self.label_temp.setFrameShape(QtWidgets.QFrame.Box)
        self.label_temp.setTextFormat(QtCore.Qt.AutoText)
        self.label_temp.setAlignment(QtCore.Qt.AlignCenter)
        self.label_temp.setOpenExternalLinks(False)
        self.label_temp.setObjectName("label_temp")
        #Gyroskop label
        self.label_gyro = QtWidgets.QLabel(self.centralwidget)
        self.label_gyro.setGeometry(QtCore.QRect(470, 440, 110, 40))
        self.label_gyro.setBaseSize(QtCore.QSize(0, 0))
        self.label_gyro.setFrameShape(QtWidgets.QFrame.Box)
        self.label_gyro.setTextFormat(QtCore.Qt.AutoText)
        self.label_gyro.setAlignment(QtCore.Qt.AlignCenter)
        self.label_gyro.setOpenExternalLinks(False)
        self.label_gyro.setObjectName("label_gyro")
        #UART label
        self.label_UART = QtWidgets.QLabel(self.centralwidget)
        self.label_UART.setGeometry(QtCore.QRect(20, 450, 110, 31))
        self.label_UART.setBaseSize(QtCore.QSize(0, 0))
        self.label_UART.setFrameShape(QtWidgets.QFrame.Box)
        self.label_UART.setTextFormat(QtCore.Qt.AutoText)
        self.label_UART.setAlignment(QtCore.Qt.AlignCenter)
        self.label_UART.setOpenExternalLinks(False)
        self.label_UART.setObjectName("label_UART")
        
        self.layoutWidget = QtWidgets.QWidget(self.centralwidget)
        self.layoutWidget.setGeometry(QtCore.QRect(30, 550, 311, 22))
        self.layoutWidget.setObjectName("layoutWidget")
        
        self.horizontalLayout_2 = QtWidgets.QHBoxLayout(self.layoutWidget)
        self.horizontalLayout_2.setContentsMargins(0, 0, 0, 0)
        self.horizontalLayout_2.setObjectName("horizontalLayout_2")
        #UART RX label
        self.label_UART_RX = QtWidgets.QLabel(self.layoutWidget)
        self.label_UART_RX.setObjectName("label_UART_RX")
        
        self.horizontalLayout_2.addWidget(self.label_UART_RX)
        #lineEdit RX
        self.lineEdit_RX = QtWidgets.QLineEdit(self.layoutWidget)
        self.lineEdit_RX.setEnabled(True)
        self.lineEdit_RX.setObjectName("lineEdit_RX")
        self.lineEdit_RX.setReadOnly(True)
        
        self.horizontalLayout_2.addWidget(self.lineEdit_RX)
        
        self.layoutWidget1 = QtWidgets.QWidget(self.centralwidget)
        self.layoutWidget1.setGeometry(QtCore.QRect(31, 490, 391, 25))
        self.layoutWidget1.setObjectName("layoutWidget1")
        
        self.horizontalLayout = QtWidgets.QHBoxLayout(self.layoutWidget1)
        self.horizontalLayout.setContentsMargins(0, 0, 0, 0)
        self.horizontalLayout.setObjectName("horizontalLayout")
        #label UART TX
        self.label_UART_TX = QtWidgets.QLabel(self.layoutWidget1)
        self.label_UART_TX.setObjectName("label_UART_TX")
        
        self.horizontalLayout.addWidget(self.label_UART_TX)
        #lineEdit TX
        self.lineEdit_TX = QtWidgets.QLineEdit(self.layoutWidget1)
        self.lineEdit_TX.setObjectName("lineEdit_TX")
        
        self.horizontalLayout.addWidget(self.lineEdit_TX)
        #BTN UART TX
        self.pushButton_UART_TX = QtWidgets.QPushButton(self.layoutWidget1)
        self.pushButton_UART_TX.setObjectName("pushButton_UART_TX")
        
        self.horizontalLayout.addWidget(self.pushButton_UART_TX)
        #label LED0 - image
        self.label_LED0 = QtWidgets.QLabel(self.centralwidget)
        self.label_LED0.setGeometry(QtCore.QRect(20, 80, 171, 81))
        self.label_LED0.setText("")
        self.label_LED0.setObjectName("label_LED0")
        self.label_LED0.setPixmap(QPixmap("bulb_0.jpg"))
 
        #label LED1 - image
        self.label_LED1 = QtWidgets.QLabel(self.centralwidget)
        self.label_LED1.setGeometry(QtCore.QRect(220, 80, 171, 81))
        self.label_LED1.setText("")
        self.label_LED1.setObjectName("label_LED1")
        self.label_LED1.setPixmap(QPixmap("bulb_0.jpg"))
        #label LED2 - image
        self.label_LED2 = QtWidgets.QLabel(self.centralwidget)
        self.label_LED2.setGeometry(QtCore.QRect(20, 240, 171, 81))
        self.label_LED2.setText("")
        self.label_LED2.setObjectName("label_LED2")
        self.label_LED2.setPixmap(QPixmap("bulb_0.jpg"))
        
        #BTN CONNECT
        self.pushButton_CONNECT = QtWidgets.QPushButton(self.centralwidget)
        self.pushButton_CONNECT.setGeometry(QtCore.QRect(40, 730, 131, 31))
        self.pushButton_CONNECT.setObjectName("pushButton_CONNECT")
        
        self.label_CONNECT = QtWidgets.QLabel(self.centralwidget)
        self.label_CONNECT.setGeometry(QtCore.QRect(200, 700, 100, 100))
        self.label_CONNECT.setText("")
        self.label_CONNECT.setObjectName("label_CONNECT")
        self.label_CONNECT.setPixmap(QPixmap("red.jpg"))
        
        #Signal
        self.pushButton_LED0.clicked.connect(self.label_led0_change)
        self.pushButton_LED1.clicked.connect(self.label_led1_change)
        self.pushButton_LED2.clicked.connect(self.label_led2_change)
        self.pushButton_UART_TX.clicked.connect(self.UART_send_data)
        self.pushButton_CONNECT.clicked.connect(ble_connect)
        
        MainWindow.setCentralWidget(self.centralwidget)
        self.statusbar = QtWidgets.QStatusBar(MainWindow)
        self.statusbar.setObjectName("statusbar")
        MainWindow.setStatusBar(self.statusbar)

        self.retranslateUi(MainWindow)
        QtCore.QMetaObject.connectSlotsByName(MainWindow)
        
    def label_led0_change(self):
        service_data = p.getServiceByUUID(service_data_address)
        chara_LED_temp = service_data.getCharacteristics(chara_led_address)
        chara_LED = chara_LED_temp[0]
        if self.picture_flag0 == 0:
            self.picture_flag0 = 1
            self.label_LED0.setPixmap(QPixmap("bulb_1.jpg"))
            chara_LED.write(bytes([0x21]))
        else:
            self.picture_flag0 = 0
            self.label_LED0.setPixmap(QPixmap("bulb_0.jpg"))
            chara_LED.write(bytes([0x21]))
            
            
    def label_led1_change(self):
        service_data = p.getServiceByUUID(service_data_address)
        chara_LED_temp = service_data.getCharacteristics(chara_led_address)
        chara_LED = chara_LED_temp[0]
        if self.picture_flag1 == 0:
            self.picture_flag1 = 1
            self.label_LED1.setPixmap(QPixmap("bulb_1.jpg"))
            chara_LED.write(bytes([0x22]))
        else:
            self.picture_flag1 = 0
            self.label_LED1.setPixmap(QPixmap("bulb_0.jpg"))
            chara_LED.write(bytes([0x22]))
            
            
    def label_led2_change(self):
        service_data = p.getServiceByUUID(service_data_address)
        chara_LED_temp = service_data.getCharacteristics(chara_led_address)
        chara_LED = chara_LED_temp[0]
        if self.picture_flag2 == 0:
            self.picture_flag2 = 1
            self.label_LED2.setPixmap(QPixmap("bulb_1.jpg"))
            chara_LED.write(bytes([0x24]))
        else:
            self.picture_flag2 = 0
            self.label_LED2.setPixmap(QPixmap("bulb_0.jpg"))
            chara_LED.write(bytes([0x24]))

    def update_temp_graph(self, value):
        self.graphicsView_temp.clear()
        self.temperature_data.append(value)
        self.temperature_data.pop(0)
        self.graphicsView_temp.plotItem.plot(self.temperature_data)
        
    def update_gyro_graph(self, value):
        self.graphicsView_gyro.clear()
        self.adc_data.append(value)
        self.adc_data.pop(0)
        self.graphicsView_gyro.plotItem.plot(self.adc_data)
        
    def UART_send_data(self):
        print('TX msg: ' + self.lineEdit_TX.text())
        msg = self.lineEdit_TX.text()
        service_data = p.getServiceByUUID(service_data_address)
        chara_uart_temp = service_data.getCharacteristics(chara_uart_address)
        chara_uart = chara_uart_temp[0]
        chara_uart.write(msg.encode())
        
        
    def UART_RX_update(self, text):
        self.lineEdit_RX.setText(text)
    
    def retranslateUi(self, MainWindow):
        _translate = QtCore.QCoreApplication.translate
        MainWindow.setWindowTitle(_translate("MainWindow", "MPOA 2018 GUI"))
        self.pushButton_LED0.setText(_translate("MainWindow", "LED0"))
        self.pushButton_LED1.setText(_translate("MainWindow", "LED1"))
        self.pushButton_LED2.setText(_translate("MainWindow", "LED2"))
        self.pushButton_CONNECT.setText(_translate("MainWindow", "Connect"))
        self.label_LED.setText(_translate("MainWindow", "LED Controller"))
        self.label_temp.setText(_translate("MainWindow", "Temperature"))
        self.label_gyro.setText(_translate("MainWindow", "Battery Voltage"))
        self.label_UART.setText(_translate("MainWindow", "Serial Comm"))
        self.label_UART_RX.setText(_translate("MainWindow", "RX"))
        self.label_UART_TX.setText(_translate("MainWindow", "TX"))
        self.pushButton_UART_TX.setText(_translate("MainWindow", "TX"))

from pyqtgraph import PlotWidget

############################# BLUEPY #####################################################
p_address = "D3:DF:9B:8C:EF:09"
service_data_address = "0000da7a-1212-efde-1523-785fef13d123"
chara_uart_address = "00004a87-1212-efde-1523-785fef13d123"
chara_led_address = "00002eed-1212-efde-1523-785fef13d123"
service_temp_address ="0000aaaa-1212-efde-1523-785fef13d123"
chara_temp_address ="0000cccc-1212-efde-1523-785fef13d123"

cHandle_temp = 23
cHandle_uart = 16
cHandle_led = 19

class MyDelegate(DefaultDelegate):
    #Constructor (run once on startup)  
    def __init__(self, params):
        DefaultDelegate.__init__(self)
      
    #func is caled on notifications
    def handleNotification(self, cHandle, data):
        if cHandle == cHandle_temp:
            print("Temperature")
            temperature = str(data[0]) + "." + str(data[1])
            temperaturef = float(temperature)
            ui.update_temp_graph(temperaturef)
            
            temp1 = data[2] << 8
            temp2 = data[3]
            temp = temp1 + temp2
            ADCf = float(temp)
            ui.update_gyro_graph(ADCf)
            
        elif cHandle == cHandle_uart:
            print("UART")
            data_string = data.splitlines()
            print(str(data_string))
            data_print = str(data_string[0])
            print("MSG: " + data_print[2:-1])
            ui.lineEdit_RX.setText(data_print[2:-1])
        elif cHandle == cHandle_led:
            print("LED")
            

def ble_connect():
    p.setDelegate( MyDelegate(p) )
    print("Ble peripherial is connected.")
    service_data = p.getServiceByUUID(service_data_address)
    service_temp = p.getServiceByUUID(service_temp_address)
    print("Service Data find.")
    chara_uart_temp = service_data.getCharacteristics(chara_uart_address)
    chara_uart = chara_uart_temp[0]
    print("Characteristic UART find.")
    chara_LED_temp = service_data.getCharacteristics(chara_led_address)
    chara_LED = chara_LED_temp[0]
    print("Characteristic LED find.")
    chara_temp_temp = service_temp.getCharacteristics(chara_temp_address)
    chara_temp = chara_temp_temp[0]

    led_handle_cccd = chara_LED.getHandle() + 1
    print("led_handle_cccd 0x%X" % led_handle_cccd)
    p.writeCharacteristic(led_handle_cccd, bytes([0x01, 0x00]))
    chara_LED.write(bytes([0x17]))
    time.sleep(1)

    uart_handle_cccd = chara_uart.getHandle() + 1
    print("uart_handle_cccd 0x%X" % uart_handle_cccd)
    p.writeCharacteristic(uart_handle_cccd, bytes([0x02, 0x00]))
    time.sleep(1)

    temp_handle_cccd = chara_temp.getHandle() + 1
    print("temp_handle_cccd 0x%X" % temp_handle_cccd)
    p.writeCharacteristic(temp_handle_cccd, bytes([0x01, 0x00]))
    time.sleep(1)
    ui.label_CONNECT.setPixmap(QPixmap("green.jpg"))
    ui.pushButton_CONNECT.setText("Disconnect")
    ui.pushButton_CONNECT.clicked.connect(ble_disconnect)
 
def ble_disconnect():
    p.disconnect()
    ui.label_CONNECT.setPixmap(QPixmap("red.jpg"))
    ui.pushButton_CONNECT.setText("Connect")
    ui.pushButton_CONNECT.clicked.connect(ble_connect)
    sys.exit(app.exec_())
    print("BLE disconnected.")
 

p = btle.Peripheral(p_address,"random")
ui = Ui_MainWindow()

if __name__ == "__main__":
    import sys
    app = QtWidgets.QApplication(sys.argv)
    MainWindow = QtWidgets.QMainWindow()
    ui.setupUi(MainWindow)
    MainWindow.show()  
    while True:
        if p.waitForNotifications(0.01):
            continue
        QtGui.QApplication.processEvents()
    sys.exit(app.exec_())

